/*
 * Simple cat.
 *
 * scat {<files>|-}...
 *
 * Example:
 * scat sample.txt sample.bin - | nc localhost 10000
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>

static void help()
{
  printf("scat {<files>|-}...\n");
  exit(0);
}

int main(int argc, char *argv[])
{
  int fd = -1, size, offset, r;
  char buffer[1024*4];

  argc--; argv++;
  if (argc < 1)
    help();

#ifdef WIN32
  if (!isatty(0)) setmode(0, O_BINARY);
  if (!isatty(1)) setmode(1, O_BINARY);
#endif

  while (1) {
    if (fd < 0) {
      if (argc < 1)
	break;
      usleep(100000); /* Wait */
      if (!strcmp(*argv, "-"))
	fd = 0;
      else
	fd = open(*argv, O_RDONLY);
      argc--; argv++;
    }

    r = read(fd, buffer, sizeof(buffer));
    if (r < 0)
      goto done;
    if (r == 0) {
      if (fd != 0)
	close(fd);
      fd = -1;
      continue;
    }

    size = r;
    offset = 0;

    while (size > 0) {
      r = write(1, buffer + offset, size);
      if (r < 0)
	goto done;
      size -= r;
      offset += r;
    }
  }

done:
  return 0;
}
